//------------------------------------------------------
// module  : FunctionSCVOIC.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionSCVOIC.h"


//--------------------------//
//-- Matrice de Flottant ---//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];
  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de int
//----------------------------------------------------------
int**** imatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  int**** matrix;

  matrix=new int***[fsize];
  for(int i=0;i<fsize;i++)
    matrix[i]=imatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//----------------------------------------------------------
// libere la memoire de la matrice 4d de int
//----------------------------------------------------------
void free_imatrix_4d(int**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_imatrix_3d(pmat[i],dsize);

 delete[] (pmat);
}

//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,int** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,int** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat1[i][j]=(int)mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float*** mat1,float*** mat2,int lgth,int wdth)
{
  int i,j,k;

  for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[k][i][j]=mat2[k][i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int*** mat1,int*** mat2,int lgth,int wdth)
{
  int i,j,k;

  for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[k][i][j]=mat2[k][i][j]; 
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(int** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     mat[i][j]-=(int)min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]=(int)((float)mat[i][j]*((float)GREY_LEVEL/max));      
}

/*----------------------------------------------------------*/
/* Zeros                                                    */
/*----------------------------------------------------------*/
void Zeros(float** mat,int lgth,int wdth)
{
 int i,j;

 //Fill Zeros
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  mat[i][j]=0.0;
}

//----------------------------------------------------------
// calcule le nombre de differences a chaque iteration
//----------------------------------------------------------
int DiffMatNb(int** pmatl1,int** pmatl2,int lgth,int wdth)
{
 int i,j;
 int chg;

 //>Compte NbChgt
 chg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (pmatl1[i][j]!=pmatl2[i][j]) chg++; 
       
 return chg;
}

//--------------//
// RANDOM ------//
//--------------//
//----------------------------------------------------------
// retourne un nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }


//----------//
//-- FILE --//
//----------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
int GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) return 0;
    
  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
  return 1;
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en pgm)             
//----------------------------------------------------------
void load_image_pgm(char* path,int** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char var;
  char header[100];
  char* ptr;
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".pgm")==NULL) strcat(path,".pgm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  tempc=fgets(header,100,fic);
  if ( (header[0]!=80) ||    /* 'P' */
       (header[1]!=53) ) {   /* '5' */
       fprintf(stderr,"Image %s is not PGM.\n",path);
       exit(1); }

  tempc=fgets(header,100,fic);
  while(header[0]=='#') tempc=fgets(header,100,fic);
 
  ta1=strtol(header,&ptr,0);
  ta2=atoi(ptr);
  tempc=fgets(header,100,fic);
  ta3=strtol(header,&ptr,0);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    { temp=(int)fread(&var,1,1,fic);
      img[i][j]=(int)var; }

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void load_image_ppm(char* path,int*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;

  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".ppm")==NULL) strcat(path,".ppm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,100,fic); //Comment

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,100,fic); 

      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d",&ta3);

  //affichage de l'entete
  //printf("\n\n -- Entete --");
  //printf("\n ------------");
  //printf("\n %s %s %d %d \n %d",stringTmp1,stringTmp2,ta1,ta2,ta3);
  //printf("\n %s  %d %d \n %d",stringTmp1,ta1,ta2,ta3);
  //printf("\n ----------------------------------------------------------\n\n");
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);
     
      img[2][i][j/3]=varr;        
      img[0][i][j/3]=varv;        
      img[1][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n  Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,int** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n  Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,int*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n  Sauvegarde de %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }


//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n  >> Sauvegarde dans -> %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//---------------
//---K-MEAN------
//---------------
//----------------------------------------------------------
// Identical                      
//----------------------------------------------------------
int Identical(float* VctPts,float** MtxCtrs,int nbcl,int nbpar)
{
 int k,l;
 int value=0;

 for(k=0;k<nbcl;k++) 
   { value=1;
     for(l=0;l<nbpar;l++) if (fabs(VctPts[l]-MtxCtrs[k][l])>0.01) value=0;
     if (value) return value; }
    
 return value;
}

//----------------------------------------------------------
//  K-Mean  
//    Avec Floattant
//----------------------------------------------------------
void KmeanFast(float** MatrixPts,int NbClusters,int NbPts,int NbParam,int* VctLabel,int Seed,int FlgMan)
{
 int i,j,k,l;
 int classe;
 float aleat;
 int nb;
 float  dist,distmin;
 int flag;
 
 //Allocation memoire
 float** MatrixCtrs=fmatrix_allocate_2d(NbClusters,NbParam);
 
 //Presentation
 printf("\n  >> K-Means [NbPts=%d][NbCl=%d][Dim=%d][Seed=%d]",NbPts,NbClusters,NbParam,Seed);
 srand(Seed);
 if (FlgMan) printf("\n  K-Moy > [Dist. Manhattan]"); 


 //--------------------------------------------------------------
 // -[0]- Initialize Centroid
 // --------------------------------------------------------------
  if (0)                    
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbPts/(NbClusters+2));
       for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 

  if (1)
  for(i=0;i<NbClusters;i++) 
   { nb=0;
     do { aleat=(int)((randomize())*NbPts-1); nb++; }
     while((i)&&(nb<100)&&(Identical(MatrixPts[(int)aleat],MatrixCtrs,NbClusters,NbParam)));

     if (nb>1) printf(" <|%d Essais|>",nb);

     for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 
  //------------------------------------------------------------------
  //------------------------------------------------------------------
    
 
  printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<50;l++)
   {  
       //-[1]- Select Cluster Membership
       //-------------------------------
       flag=0; classe=0;

       for(j=0;j<NbPts;j++)
          { distmin=BIGNUMBER;  

           for(i=0;i<NbClusters;i++)
              { dist=0.0; 
                
                //Euclidean distance
                if (!FlgMan)
                for(k=0;k<NbParam;k++) dist+=CARRE(MatrixCtrs[i][k]-MatrixPts[j][k]);

                //Manhattan distance
		if (FlgMan)
                for(k=0;k<NbParam;k++) dist+=fabs(MatrixCtrs[i][k]-MatrixPts[j][k]);
		     
                if (dist<distmin) { distmin=dist; classe=i; }
	      }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

       //-[2]- Stop Criterion & Info
       //---------------------------
       if ((!flag)&&(l>10))  break;
       printf("[%d>%d]",l,flag); fflush(stdout);
          
       
       //-[3]- Update Centroids For Each Clusters
       //----------------------------------------
        for(i=0;i<NbClusters;i++) 
	  {  
           nb=0;    
	   for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=0;
                      
	   for(j=0;j<NbPts;j++) if (VctLabel[j]==i)
	      { nb++;
                for(k=0;k<NbParam;k++) MatrixCtrs[i][k]+=MatrixPts[j][k]; }

           for(k=0;k<NbParam;k++) if (nb) MatrixCtrs[i][k]/=nb;
          }

   }//==============================================================
 //================================================================= 

 //FreeMemory
 if (MatrixCtrs) free_fmatrix_2d(MatrixCtrs);
}

//----------------
//  FUSION -------
//----------------
//----------------------------------------------------------
// Paint        
//----------------------------------------------------------
void Paint(float** mat,int** mattmp,int row,int col,int lgth,int wdth,int lab)
{
 if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    { 
     mattmp[row][col]=-1;

     if ((col+1)<=(wdth-1))  Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)         Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))  Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)         Paint(mat,mattmp,row-1,col,lgth,wdth,lab); 
     }

 else return;
}

//----------------------------------------------------------
// Convert <ClassRegion>              
//----------------------------------------------------------
void ConvertClassRegion(float** mat,int lgth,int wdth)
{
 int i,j,k,l,m;
 int label;
 float coul;
 int nb;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  int*  TabGrey=imatrix_allocate_1d(256);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];
  for(i=0;i<256;i++)  TabGrey[i]=0;

  //Check
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     if ((mat[i][j]>=0)&&(mat[i][j]<256)) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
   printf("   > NbClass[%d]",nb);
   fflush(stdout);
   for(i=0;i<256;i++)  TabGrey[i]=0; 

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)mat[i][j];
         //printf("[^^^^%d-%d(%d)^^^^]",i,j,(int)label);

         Paint(mat,mattmp,i,j,lgth,wdth,label);

         do 
           { coul=(int)(randomize()*255); }
         while (TabGrey[(int)coul]);

         TabGrey[(int)coul]=1;
         ++cpt;
         
         if (cpt>=255)
	    { for(m=0;m<256;m++)  TabGrey[m]=0;
              cpt=0; printf("*Regions debordent*"); }        

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mat[k][l]=(int)coul;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }
 
   //Compte Regions
   for(i=0;i<256;i++)  TabGrey[i]=0;
      
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
       printf("::NbReg[%d]",nb);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_imatrix_1d(TabGrey); 
}

//----------------------------------------------------------
//  ComputeNumberRegions          
//----------------------------------------------------------
int ComputeNumberRegions(float** mat,int lgth,int wdth)
{
 int i,j,k,l;
 int label;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  float** matx=fmatrix_allocate_2d(lgth,wdth);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matx[i][j]=(int)mat[i][j];

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)matx[i][j];
         Paint(matx,mattmp,i,j,lgth,wdth,label);          
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) matx[k][l]=cpt;
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
         cpt++;
        }
 
   //Nombre Regions
   printf("\n >> NbRegions [%d]",cpt);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_fmatrix_2d(matx);

 //Retour
 return cpt; 
}

//--------------------------------
//--------------------------------
//---GESTION----------------------
//--------------------------------
//----------------------------------------------------------
// Duplication: MatIn > MatOut[lgth][wdth] (*scale)
//----------------------------------------------------------
void Duplication(int** MatIn,int** MatOut,int scale,int lgth,int wdth)
{
 int i,j;

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatOut[i][j]=0; 

 //>Decimation Inverse
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  if ((int(i/scale)<(lgth/scale))&&(int(j/scale)<(wdth/scale))) 
     MatOut[i][j]=MatIn[(int)(i/scale)][(int)(j/scale)];
} 

//--------------------------------
//--------------------------------
//---FUSION MODEL-----------------
//--------------------------------
//----------------------------------------------------------
// NumberRegionMax
//----------------------------------------------------------
int NumberRegionMax(int*** TabSeg,int lgth,int wdth,int NbSegs)
{
 int i,j,k;
 int MaxRegions;
 int IndxSegMaxReg;
 
 MaxRegions=0;
 IndxSegMaxReg=-1;
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 if (TabSeg[k][i][j]>MaxRegions) { MaxRegions=TabSeg[k][i][j]; IndxSegMaxReg=k; }
 
 MaxRegions++;
 printf("\n  >> [%d:::MaxNumberRegions=%d]",IndxSegMaxReg,MaxRegions);

 return MaxRegions;
}

//----------------------------------------------------------
//  ComputeMatProbVoI  :: Seg_k=MatIn  
//                     :: P_k,k' ou  Card[C_k Inter C_k']
//
//----------------------------------------------------------
void ComputeMatProbVoI(int*** TabMat,int** MatIn,int lgth,int wdth,int NbSegs,int*** MatProbVoI,int NbRegMax)
{
 int i,j,k,l,m;

 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) for(m=0;m<NbRegMax;m++) 
 MatProbVoI[k][l][m]=0;

 //Compute
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 MatProbVoI[k][MatIn[i][j]][TabMat[k][i][j]]++; 
}

//----------------------------------------------------------
//  ComputePropClustKprime :: P_k' ou Card(C_k')
//
//----------------------------------------------------------
void ComputePropClustKprime(int*** TabMat,int** PropClust,int lgth,int wdth,int NbSegs,int NbRegMax)
{
 int i,j,k,l;
 
 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) PropClust[k][l]=0; 

 //Estimator
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 PropClust[k][TabMat[k][i][j]]++;
}


//----------------------------------------------------------
//  ComputePropClust :: P_k ou Card(C_k)
//
//----------------------------------------------------------
void ComputePropClustK(int* HistReg,int** SegReg,int lgth,int wdth,int NbRegMax)
{
 int i,j,k;

 //LOOP
 for(k=0;k<NbRegMax;k++) HistReg[k]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  HistReg[SegReg[i][j]]++;
}

//----------------------------------------------------------
// float VariationInformation
//----------------------------------------------------------
float VariationInformation(int** MatReg1,int** MatReg2,int lgth,int wdth)
{
 int i,j,k,l;
 int NbReg1,NbReg2;
 float H_MtRg1,H_MtRg2,I_MtRg1Rg2,VoI;
 float tmp;
 float prop1,prop2;

 //EstimateNbRegMax
 NbReg1=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatReg1[i][j]>NbReg1) NbReg1=MatReg1[i][j];
 NbReg1++;
 NbReg2=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatReg2[i][j]>NbReg2) NbReg2=MatReg2[i][j];
 NbReg2++;

 //AllocationMemory
 int*  HistMatReg1=imatrix_allocate_1d(NbReg1);
 int*  HistMatReg2=imatrix_allocate_1d(NbReg2);
 int** HistMatRegJoin=imatrix_allocate_2d(NbReg1,NbReg2);

 //ComputeHistoReg
 for(k=0;k<NbReg1;k++) HistMatReg1[k]=0; 
 for(k=0;k<NbReg2;k++) HistMatReg2[k]=0; 

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    {  HistMatReg1[MatReg1[i][j]]++;
       HistMatReg2[MatReg2[i][j]]++; }

 //Compute<Entropy>H(MatReg1)_H(MatReg2)
 H_MtRg1=0.0;
 for(k=0;k<NbReg1;k++)
   { tmp=((float)HistMatReg1[k]/(float)(wdth*lgth)); 
     if(tmp) H_MtRg1-=tmp*log2(tmp); } 
 //printf("[Entropy(Rg1)=%.3f]",H_MtRg1);

 H_MtRg2=0.0;
 for(k=0;k<NbReg2;k++)
   { tmp=((float)HistMatReg2[k]/(float)(wdth*lgth)); 
     if (tmp) H_MtRg2-=tmp*log2(tmp); } 
 //printf("[Entropy(Rg2)=%.3f]",H_MtRg2);

 //Compute JointEntropy
 for(k=0;k<NbReg1;k++) for(l=0;l<NbReg2;l++) HistMatRegJoin[k][l]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) HistMatRegJoin[MatReg1[i][j]][MatReg2[i][j]]++; 

 I_MtRg1Rg2=0.0;
 for(k=0;k<NbReg1;k++) for(l=0;l<NbReg2;l++) 
   { tmp=(((float)HistMatRegJoin[k][l])/(wdth*lgth));
     prop1=(float)HistMatReg1[k]/(wdth*lgth);
     prop2=(float)HistMatReg2[l]/(wdth*lgth);
     if (tmp) I_MtRg1Rg2+=tmp*log2(tmp/(prop1*prop2)); }

 //Compute VariationInformation
 VoI=H_MtRg1+H_MtRg2-(2*I_MtRg1Rg2);
 //printf("[VoI=%.3f]<%.3f?",H_MtRg1,log2(wdth*lgth));
 
  //FreeMemory
 if (HistMatReg1) free_imatrix_1d(HistMatReg1);
 if (HistMatReg2) free_imatrix_1d(HistMatReg2);
 if (HistMatRegJoin) free_imatrix_2d(HistMatRegJoin);

 //Return
 if (VoI<0) VoI=0.0;
 return VoI;
}

//----------------------------------------------------------
// float MoyVariationInformation
//----------------------------------------------------------
float MoyVariationInformation(int** MatReg,int*** TabMatReg,int lgth,int wdth,int nb,int info)
{
 int k;
 float VoI,MoyVoI;
 int cpt;

 //LOOP
 MoyVoI=0.0;
 cpt=0;
 for(k=0;k<nb;k++) 
    { VoI=VariationInformation(MatReg,TabMatReg[k],lgth,wdth);
      MoyVoI+=VoI;
      cpt++;
      if (info) printf("[%d:%.1f] ",k,VoI); }

 MoyVoI/=(float)(cpt);
 if (info) printf("\n [MoyVoI=%.3f]",MoyVoI);

 //Retour
 return MoyVoI;
}


//----------------------------------------------------------
// int Select
//----------------------------------------------------------
int SelectSegMap(int*** TabMatReg,int lgth,int wdth,int nb,float* TabVoI)
{
 int k;
 float MinMoyVoI,VoIMoy;
 int IndxMinMoyVoI;

 //>MemoryAllocation
 int** MatInt=imatrix_allocate_2d(lgth,wdth);

 //>LOOP
 MinMoyVoI=10000;
 IndxMinMoyVoI=-1;
 for(k=0;k<nb;k++)
   { //printf("\n  [nb::%d]",k);
     //fflush(stdout);
     CopyMat(MatInt,TabMatReg[k],lgth,wdth);
     VoIMoy=MoyVariationInformation(MatInt,TabMatReg,lgth,wdth,nb,0);
     TabVoI[k]=VoIMoy;
     if (VoIMoy<MinMoyVoI) { MinMoyVoI=VoIMoy; IndxMinMoyVoI=k; } 
   }

 //>FreeMemory 
 if (MatInt) free_imatrix_2d(MatInt);

 //>Info
 printf("\n  >> SelectSegMap[%d::VoIMin=%.3f]",IndxMinMoyVoI,MinMoyVoI);

 //>Return
 return IndxMinMoyVoI;
}

//----------------------------------------------------------
// int Classify
//----------------------------------------------------------
void Classify(int*** TabMatReg,int lgth,int wdth,int nb,float* TabVoI)
{
 int k;

 //>MemoryAllocation
 int***  TabSeg=imatrix_allocate_3d(nb,lgth,wdth);
 float** Tab2DVoI=fmatrix_allocate_2d(nb,2);

 //>Init
 for(k=0;k<nb;k++) { Tab2DVoI[k][0]=TabVoI[k]; Tab2DVoI[k][1]=k; }
 sort(Tab2DVoI,0,nb,2);

 //>Info
 for(k=0;k<nb;k++) printf("\n  [%d...%.0f::%.2f]",k,Tab2DVoI[k][1],Tab2DVoI[k][0]);
 
 //>OutputRes
 for(k=0;k<nb;k++) CopyMat(TabSeg[k],TabMatReg[(int)(Tab2DVoI[k][1])],lgth,wdth);
 for(k=0;k<nb;k++) CopyMat(TabMatReg[k],TabSeg[k],lgth,wdth);

 //FreeMemory 
 if (TabSeg)   free_imatrix_3d(TabSeg,nb);
 if (Tab2DVoI) free_fmatrix_2d(Tab2DVoI);
}

//----------------------------------------------------------------
//  quickSort
//  ---------     Arr[l][c]   :: Arr[l][0] a classer
//                            :: l \in [beg::end]
//                            :: c \in [0::Nb]
//----------------------------------------------------------------
void sort(float** arr,int beg,int end,int Nb)
{
 int k;

 //>Sort
 if (end>beg+1)
  {
    float piv=arr[beg][0];
    int l=beg+1,r=end;
    while (l<r)
    {
      if (arr[l][0]<=piv) l++;  
      else { r--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[r][k]); }
    }
    l--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[beg][k]);
    sort(arr,beg,l,Nb);
    sort(arr,r,end,Nb);
  }
} 

void swap(float* a,float* b)
{
  float t=*a; *a=*b; *b=t;
}

//----------------------
//----------------------
//----------------------
//----------------------------------------------------------
// FillVectNeighb
//----------------------------------------------------------
void FillVectNeighb(int** Seg,int lgth,int wdth,int* Vct,int SzW,int row,int col)
{
 int k,l;
 int SzWdiv2=SzW/2;
 int posr,posc;
 int nb;

 //Fill
 nb=0;
 for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) Vct[(k*SzW)+l]=-1;
 for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
          posr=row-(SzWdiv2)+k;
          posc=col-(SzWdiv2)+l;
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;

          if ((int)(Seg[row][col])!=(int)(Seg[posr][posc]))
	     { Vct[nb]=(int)(Seg[posr][posc]);
               nb++; }
	}
}

//----------------------------------------------------------
// GiveRandomVal
//----------------------------------------------------------
int GiveRandomLab(int* Vct,int LgthVct)
{
 int k;
 int nb,index;
 
 //FindNb&RandomVal
 for(k=0,nb=0;k<LgthVct;k++) 
   { if ((int)Vct[k]!=-1) nb=k; 
      else break; }

 index=(int)((float)nb*randomize());
 return Vct[index];
}

//-----------------------------------------------------------------------
// Compute Local NRJ VoI
// ---------------------
//
// At Pixel [row][col]  i.e. MatReg[row][col]  On choisit <lab1>     
//
//         using >> MatProbVoI[NbSegs][k][k']    (P_k_k') (k<NbRegionMax)
//               >> PropClust[NbSegs][k']        (P_k')
//               >> HistMatReg[k]                (P_k)
//               >> TabMatReg[NbSegs][row][col]  Set Of Segmnetations To Be Fused
//
//-----------------------------------------------------------------------
float ComputeLocNrjVoI(int** MatReg,int* HistMatReg,int row,int col,int Lab1,int lgth,int wdth,\
int*** TabMatReg,int Lab2,int*** MatProbVoI,int** PropClust,int NbSegs)
{ 
 int n,p;
 int NbBinLab1,NbBinLab2;
 double Entropy;
 double CrossEntropy;
 double VoI;
 double tmp1,tmp2;
 double NbPix;
 double nLab1,nLab2,nk_prime;

 NbPix=(wdth*lgth);

 //================
 //Entropy : H(C_k)
 //================
 NbBinLab1=HistMatReg[Lab1];
 NbBinLab2=HistMatReg[Lab2];
 
 //[Lab2-->Lab1]
 if (MatReg[row][col]!=Lab1)
    { NbBinLab1++;
      NbBinLab2--; }

 Entropy=0.0;
   { tmp1=(float)NbBinLab1/(float)(NbPix);
     tmp2=(float)NbBinLab2/(float)(NbPix);
     if (tmp1) Entropy-=(tmp1*log2(tmp1));
     if (tmp2) Entropy-=(tmp2*log2(tmp2)); }

 //============================
 //Cross-Entropy : I(C_k,C_k')
 //============================
 CrossEntropy=0.0;
 nLab1=nLab2=0;
 for(n=0;n<NbSegs;n++) 
   {
    p=TabMatReg[n][row][col];
    nk_prime=NbPix/PropClust[n][p];

    if (MatReg[row][col]!=Lab1) //[Lab2-->Lab1]
       { tmp1=(float)(MatProbVoI[n][Lab1][p]+1)/NbPix;
         tmp2=(float)(MatProbVoI[n][Lab2][p]-1)/NbPix;

         nLab1=NbPix/(HistMatReg[Lab1]+1);
         nLab2=NbPix/(HistMatReg[Lab2]-1); }

    else //[Lab1 & Lab2 <NoChange>]
	{ tmp1=(float)(MatProbVoI[n][Lab1][p])/NbPix;
          tmp2=(float)(MatProbVoI[n][Lab2][p])/NbPix;

          nLab1=NbPix/HistMatReg[Lab1];
          nLab2=NbPix/HistMatReg[Lab2]; }
  
          if (tmp1<0) tmp1=0;
          if (tmp2<0) tmp2=0;
	  if (tmp1) CrossEntropy+=(tmp1*log2(tmp1*nLab1*nk_prime));
          if (tmp2) CrossEntropy+=(tmp2*log2(tmp2*nLab2*nk_prime)); 
   }

 //====================================
 //VariationInformation : VI(C_k,C_k')
 //====================================
 VoI=(NbSegs*Entropy)-(2.0*CrossEntropy);

 //Return
 return VoI;
}

//----------------------------------------------------------
// ICM_VoILoc
//----------------------------------------------------------   
void ICM_VoILoc(int** MatRegIn,int** MatRegOut,int*** TabMatReg,int lgth,int wdth,int NbSegs,int NbIter)
{
 int i,j,k; 
 int n,p;
 int NbRegMaxSegIn,NbRegions,NbRegMaxTabSeg;
 int Lab1,Lab2;
 int nbchgt;
 float VoI;
 float DeltaNrj,nrj1,nrj2;
 float VoI_old;

 //EstimationParam
 NbRegMaxSegIn=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatRegIn[i][j]>NbRegMaxSegIn) NbRegMaxSegIn=MatRegIn[i][j];
 NbRegMaxSegIn++;
 NbRegions=NbRegMaxSegIn;
 NbRegMaxTabSeg=NumberRegionMax(TabMatReg,lgth,wdth,NbSegs);
 
 //AllocationMemory
 int**  SegTmp1=imatrix_allocate_2d(lgth,wdth);
 int**  SegTmp2=imatrix_allocate_2d(lgth,wdth);
 int*   VctNeighb=imatrix_allocate_1d(SIZENEIGHB*SIZENEIGHB);
 int*   HistRegSeg=imatrix_allocate_1d(NbRegMaxSegIn);
 int*** MatProbVoI=imatrix_allocate_3d(NbSegs,NbRegMaxTabSeg,NbRegMaxTabSeg);
 int**  PropClust=imatrix_allocate_2d(NbSegs,NbRegMaxTabSeg);

 //Compute [P_k] [P_k_k'] [P_k'] 
 ComputePropClustKprime(TabMatReg,PropClust,lgth,wdth,NbSegs,NbRegMaxTabSeg);
 ComputePropClustK(HistRegSeg,MatRegIn,lgth,wdth,NbRegMaxSegIn);  
 ComputeMatProbVoI(TabMatReg,MatRegIn,lgth,wdth,NbSegs,MatProbVoI,NbRegMaxTabSeg);
 
 //>Init
 CopyMat(SegTmp1,MatRegIn,lgth,wdth);
 VoI=MoyVariationInformation(MatRegIn,TabMatReg,lgth,wdth,NbSegs,0);
 printf("\n\n   > ICM_VoILoc::[NbIter=%d][NbRegions=%d][NbSegs=%d][VoI=%.5f]",NbIter,NbRegions,NbSegs,VoI); 
 fflush(stdout);

  //====================================================================
  //ICM_VoILoc    [MatRegIn >>> MatRegOut]
  //====================================================================
  for(k=0;k<NbIter;k++)
     {
      if (!(k%1)) 
      CopyMat(SegTmp2,SegTmp1,lgth,wdth);

      //MiseAJour[P_k_k'::P_k'::P_k]    
      ComputePropClustK(HistRegSeg,SegTmp1,lgth,wdth,NbRegMaxSegIn);
      ComputePropClustKprime(TabMatReg,PropClust,lgth,wdth,NbSegs,NbRegMaxTabSeg);
      ComputeMatProbVoI(TabMatReg,SegTmp1,lgth,wdth,NbSegs,MatProbVoI,NbRegMaxTabSeg);

      //-----------------------------------------------------------
      // Loop Img > Loop Pixels
      //------------------------------------------------------------
      for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
            {
               //Gibbs Sampling Record
               Lab1=SegTmp1[i][j];

               FillVectNeighb(SegTmp1,lgth,wdth,VctNeighb,SIZENEIGHB,i,j);
               Lab2=GiveRandomLab(VctNeighb,SIZENEIGHB*SIZENEIGHB);

               //4ConnexityRequestedElseContinue 
	       if (!((Lab2==SegTmp1[i+1][j])||(Lab2==SegTmp1[i-1][j])||(Lab2==SegTmp1[i][j-1])||(Lab2==SegTmp1[i][j+1])))
	       continue;            

               //NoDifferentNeighborsElseContinue
	       if (Lab2==-1)
               continue;
 
	       nrj1=ComputeLocNrjVoI(SegTmp1,HistRegSeg,i,j,Lab1,lgth,wdth,TabMatReg,Lab2,MatProbVoI,PropClust,NbSegs);
               nrj2=ComputeLocNrjVoI(SegTmp1,HistRegSeg,i,j,Lab2,lgth,wdth,TabMatReg,Lab1,MatProbVoI,PropClust,NbSegs);  
               DeltaNrj=nrj2-nrj1;

               //Lab1->Lab2 At[row=i;col=j]
               if (DeltaNrj<0) 
		 { 
                   SegTmp1[i][j]=Lab2;

                   //RemiseAJour[HistRegSeg][P_k]
                   HistRegSeg[Lab1]--;
                   HistRegSeg[Lab2]++; 
                   if (HistRegSeg[Lab1]<=0) { HistRegSeg[Lab1]=0; printf("*"); }

                   //RemiseAJour[MatProbVoI][P_k_k']
                   for(n=0;n<NbSegs;n++) 
		      { p=TabMatReg[n][i][j]; 
                        MatProbVoI[n][Lab1][p]--; 
                        MatProbVoI[n][Lab2][p]++; }                
                 }
           
             }//End_Loop_Pixel------------------------------------------  

          //>Info
          if (!(k%1))
	    {  VoI_old=VoI;
               VoI=MoyVariationInformation(SegTmp1,TabMatReg,lgth,wdth,NbSegs,0);    
               nbchgt=DiffMatNb(SegTmp2,SegTmp1,lgth,wdth);
               if ((nbchgt<2)&&(k>10)) break;
               printf("\n  [%d]>%.5f  [NbChgt=%d]",k,VoI,nbchgt); 
               fflush(stdout); }

         }//End_ICM===========================================================================
  
 //Nrj_finale[ImgRes] 
 CopyMat(MatRegOut,SegTmp1,lgth,wdth);
 VoI=MoyVariationInformation(MatRegOut,TabMatReg,lgth,wdth,NbSegs,0);
 printf("\n   >> [VoI:%.5f]\n",VoI); 
 
 //FreeMemory
 if (SegTmp1)    free_imatrix_2d(SegTmp1); 
 if (SegTmp2)    free_imatrix_2d(SegTmp2); 
 if (HistRegSeg) free_imatrix_1d(HistRegSeg);
 if (VctNeighb)  free_imatrix_1d(VctNeighb);
 if (MatProbVoI) free_imatrix_3d(MatProbVoI,NbSegs);
 if (PropClust)  free_imatrix_2d(PropClust);
}

//--------------------------
//--------------------------
//----------------------------------------------------------
// VOIBFM  << Init: Best of NSEGS >>
//----------------------------------------------------------    
void VoibfmM(int*** TabSeg,int NBSEGS,float** mat_seg,int lgth,int wdth)
{
 int IndxBestSeg;
 
 //>MemoryAllocation
 float**  Mat2=fmatrix_allocate_2d(lgth,wdth);
 int**    MatInt1=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt2=imatrix_allocate_2d(lgth,wdth);
 float*   TabVoI=fmatrix_allocate_1d(NBSEGS);

 //>[1]::Init::Classification_&_Best->MatInt1
 IndxBestSeg=SelectSegMap(TabSeg,lgth,wdth,NBSEGS,TabVoI);
 Classify(TabSeg,lgth,wdth,NBSEGS,TabVoI);
 CopyMat(MatInt1,TabSeg[0],lgth,wdth);

 //>[2]::ICM_VoILoc
 ICM_VoILoc(MatInt1,MatInt2,TabSeg,lgth,wdth,NBSEGS,ITER_ICM); 
 
 //>[3]::Cleaning
 CopyMat(Mat2,MatInt2,lgth,wdth);

 //>Save
 ConvertClassRegion(Mat2,lgth,wdth);
 CopyMat(mat_seg,Mat2,lgth,wdth);

 //>FreeMemory 
 if (Mat2)     free_fmatrix_2d(Mat2);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (TabVoI)   free_fmatrix_1d(TabVoI); 
}

//----------------------------------------------------------
// VOIBFM  << Init: Best of NSEGS LowRes > HighRes >>
//----------------------------------------------------------    
void VoibfmM2(int*** TabSeg,int NBSEGS,float** mat_seg,int lgth,int wdth)
{ 
 int i,j,k;
 int IndxBestSeg;

 //>Cst
 const int SC=64;
 
 //>MemoryAllocation
 float**  Mat2=fmatrix_allocate_2d(lgth,wdth);
 int**    MatInt1=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt2=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt3=imatrix_allocate_2d(lgth,wdth);
 float*   TabVoI=fmatrix_allocate_1d(NBSEGS);
 int**  MatInt1_=imatrix_allocate_2d(lgth/SC,wdth/SC);
 int**  MatInt2_=imatrix_allocate_2d(lgth/SC,wdth/SC);
 int*** TabSeg_=imatrix_allocate_3d(NBSEGS,lgth/SC,wdth/SC);

 //>Init::Classification_&_Best->MatInt1
 IndxBestSeg=SelectSegMap(TabSeg,lgth,wdth,NBSEGS,TabVoI);
 Classify(TabSeg,lgth,wdth,NBSEGS,TabVoI);
 CopyMat(MatInt1,TabSeg[0],lgth,wdth);

 //>Init
 for(k=0;k<NBSEGS;k++) for(i=0;i<lgth/SC;i++) for(j=0;j<wdth/SC;j++) 
 if (((i*SC)<lgth)&&((j*SC)<wdth)) TabSeg_[k][i][j]=TabSeg[k][i*SC][j*SC];

 for(i=0;i<lgth/SC;i++) for(j=0;j<wdth/SC;j++)  
 if (((i*SC)<lgth)&&((j*SC)<wdth)) MatInt1_[i][j]=MatInt1[i*SC][j*SC];

 //>Optimization
 ICM_VoILoc(MatInt1_,MatInt2_,TabSeg_,lgth/SC,wdth/SC,NBSEGS,ITER_ICM); 
 Duplication(MatInt2_,MatInt1,SC,lgth,wdth);
 printf("  >> [Duplication]");
 fflush(stdout);
 ICM_VoILoc(MatInt1,MatInt2,TabSeg,lgth,wdth,NBSEGS,ITER_ICM); 
  
 //>Cleaning
 CopyMat(Mat2,MatInt2,lgth,wdth); 
 ConvertClassRegion(Mat2,lgth,wdth);
 CopyMat(mat_seg,Mat2,lgth,wdth);

 //>FreeMemory 
 if (Mat2)     free_fmatrix_2d(Mat2);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (MatInt3)  free_imatrix_2d(MatInt3);
 if (TabVoI)   free_fmatrix_1d(TabVoI); 
 if (MatInt1_) free_imatrix_2d(MatInt1_);
 if (MatInt2_) free_imatrix_2d(MatInt2_);
 if (TabSeg_)  free_imatrix_3d(TabSeg_,NBSEGS);
}

//----------------------------------------------------------
// VOIBFM  << Init: Lines_Hor_Vert LowRes > HighRes >>
//----------------------------------------------------------    
void Voibfm(int*** TabSeg,int NBSEGS,float** mat_seg,int lgth,int wdth)
{ 
 int i,j,k,p;
 int nb;
 float VoI,VoI_Min;

 //>Cst
 const int SC=64;
 
 //>MemoryAllocation
 float**  Mat2=fmatrix_allocate_2d(lgth,wdth);
 int**    MatInt1=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt2=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt3=imatrix_allocate_2d(lgth,wdth);
 float*   TabVoI=fmatrix_allocate_1d(NBSEGS);
 int**  MatInt1_=imatrix_allocate_2d(lgth/SC,wdth/SC);
 int**  MatInt2_=imatrix_allocate_2d(lgth/SC,wdth/SC);
 int*** TabSeg_=imatrix_allocate_3d(NBSEGS,lgth/SC,wdth/SC);

 //>Init
 for(k=0;k<NBSEGS;k++) for(i=0;i<lgth/SC;i++) for(j=0;j<wdth/SC;j++) 
 if (((i*SC)<lgth)&&((j*SC)<wdth)) TabSeg_[k][i][j]=TabSeg[k][i*SC][j*SC];

 //>LOOP____________________________
 VoI_Min=BIGNUMBER;
 for(p=0;p<2;p++)
    {
     //>Lignes_Hor__
     if (p==0)
     { for(i=0;i<lgth;i++) { nb=(int)(i/(lgth/4.0)); for(j=0;j<wdth;j++)  Mat2[i][j]=nb; }
       //SaveImagePgm((char*)"MatDebugH","",Mat2,lgth,wdth);
       //exit(-1);
     }

     //>Lignes_Vert__
     if (p==1)
     { for(j=0;j<wdth;j++) { nb=(int)(j/(wdth/4.0)); for(i=0;i<lgth;i++)  Mat2[i][j]=nb; }
       //SaveImagePgm((char*)"MatDebugV","",Mat2,lgth,wdth);
       //exit(-1);
     }

     //>Record
     for(i=0;i<lgth/SC;i++) for(j=0;j<wdth/SC;j++)  
     if (((i*SC)<lgth)&&((j*SC)<wdth)) MatInt1_[i][j]=(int)Mat2[i*SC][j*SC];

     //>Optimization
     //SaveImagePgm((char*)"MatDebug1","",MatInt1_,lgth/SC,wdth/SC);
     ICM_VoILoc(MatInt1_,MatInt2_,TabSeg_,lgth/SC,wdth/SC,NBSEGS,ITER_ICM); 
     Duplication(MatInt2_,MatInt1,SC,lgth,wdth);
     //SaveImagePgm((char*)"MatDebug2","",MatInt1,lgth,wdth);
     //exit(-1);
     printf("  >> [Duplication<%d>]",p);
     fflush(stdout);
     ICM_VoILoc(MatInt1,MatInt2,TabSeg,lgth,wdth,NBSEGS,ITER_ICM); 
      
     //>Best?
     VoI=MoyVariationInformation(MatInt2,TabSeg,lgth,wdth,NBSEGS,0); 
     if (VoI<VoI_Min) { VoI_Min=VoI; CopyMat(MatInt3,MatInt2,lgth,wdth); }
    }
 
 //>Info
 VoI=MoyVariationInformation(MatInt3,TabSeg,lgth,wdth,NBSEGS,0); 
 printf("   >> [Best:VoI:%.5f]",VoI);
 CopyMat(MatInt2,MatInt3,lgth,wdth);
  
 //>Cleaning
 CopyMat(Mat2,MatInt2,lgth,wdth); 
 ConvertClassRegion(Mat2,lgth,wdth);
 CopyMat(mat_seg,Mat2,lgth,wdth);

 //>FreeMemory 
 if (Mat2)     free_fmatrix_2d(Mat2);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (MatInt3)  free_imatrix_2d(MatInt3);
 if (TabVoI)   free_fmatrix_1d(TabVoI); 
 if (MatInt1_) free_imatrix_2d(MatInt1_);
 if (MatInt2_) free_imatrix_2d(MatInt2_);
 if (TabSeg_)  free_imatrix_3d(TabSeg_,NBSEGS);
}

//----------------------------------------------------------
// VOIBFM  << Init: Lines_Hor_Vert >>
//----------------------------------------------------------    
void Voibfm_(int*** TabSeg,int NBSEGS,float** mat_seg,int lgth,int wdth)
{
 int i,j,p;
 int nb;
 float VoI,VoI_Min;
 
 //>MemoryAllocation
 float**  Mat2=fmatrix_allocate_2d(lgth,wdth);
 int**    MatInt1=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt2=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt3=imatrix_allocate_2d(lgth,wdth);
 float*   TabVoI=fmatrix_allocate_1d(NBSEGS);

 //>LOOP____________________________
 VoI_Min=BIGNUMBER;
 for(p=0;p<2;p++)
    {
     //>Lignes_Hor__
     if (p==0)
     for(i=0;i<lgth;i++) { nb=(int)(i/(lgth/4.0)); for(j=0;j<wdth;j++)  Mat2[i][j]=nb; }

     //>Lignes_Vert__
     if (p==1)
     for(j=0;j<wdth;j++) { nb=(int)(j/(wdth/4.0)); for(i=0;i<lgth;i++)  Mat2[i][j]=nb; }

     //>Record
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatInt1[i][j]=(int)Mat2[i][j];

     //>Optimization
     ICM_VoILoc(MatInt1,MatInt2,TabSeg,lgth,wdth,NBSEGS,100); 
      
     //>Best?
     VoI=MoyVariationInformation(MatInt2,TabSeg,lgth,wdth,NBSEGS,0); 
     if (VoI<VoI_Min) { VoI_Min=VoI; CopyMat(MatInt3,MatInt2,lgth,wdth); }
    }
 
 //>Info
 VoI=MoyVariationInformation(MatInt3,TabSeg,lgth,wdth,NBSEGS,0); 
 printf("   >> [Best:VoI:%.5f]",VoI);
 CopyMat(MatInt2,MatInt3,lgth,wdth);
  
 //>Cleaning
 CopyMat(Mat2,MatInt2,lgth,wdth); 
 ConvertClassRegion(Mat2,lgth,wdth);
 CopyMat(mat_seg,Mat2,lgth,wdth);

 //>FreeMemory 
 if (Mat2)     free_fmatrix_2d(Mat2);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (MatInt3)  free_imatrix_2d(MatInt3);
 if (TabVoI)   free_fmatrix_1d(TabVoI); 
}

//----------------------------------------------------------
// VOIBFM  << Init: MatxCtrSegs[] >>
//----------------------------------------------------------    
void VoibfmI(int*** TabSeg,int NBSEGS,float** mat_seg,int lgth,int wdth)
{
 //>MemoryAllocation
 float**  Mat2=fmatrix_allocate_2d(lgth,wdth);
 int**    MatInt1=imatrix_allocate_2d(lgth,wdth);
 int**    MatInt2=imatrix_allocate_2d(lgth,wdth);
 
 //>[1]::Init::mat_seg
 CopyMat(MatInt1,mat_seg,lgth,wdth);

 //>[2]::ICM_VoILoc
 ICM_VoILoc(MatInt1,MatInt2,TabSeg,lgth,wdth,NBSEGS,ITER_ICM); 
 
 //>[3]::Cleaning
 CopyMat(Mat2,MatInt2,lgth,wdth);

 //>Save
 ConvertClassRegion(Mat2,lgth,wdth);
 CopyMat(mat_seg,Mat2,lgth,wdth);

 //>FreeMemory 
 if (Mat2)     free_fmatrix_2d(Mat2);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
}
