//------------------------------------------------------
// module  : FunctionVOIFBM.h
// auteur  : Ayman Khlif and Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// INCLUDES FIles --------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>
#include <sys/resource.h>

#include "SCVOIC.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define BIGNUMBER 100000000
#define TROIS 3
#define NCHAR 200

#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))

//------------------------------------------------
// FunctionSCVOIC.cc
//------------------------------------------------
//>MatrixAllocation
float*   fmatrix_allocate_1d(int);
float**  fmatrix_allocate_2d(int,int);
float*** fmatrix_allocate_3d(int,int,int);
int*     imatrix_allocate_1d(int);
int**    imatrix_allocate_2d(int,int);
int***   imatrix_allocate_3d(int,int,int);
int****  imatrix_allocate_4d(int,int,int,int);
void     free_fmatrix_1d(float*);
void     free_fmatrix_2d(float**);
void     free_fmatrix_3d(float***,int);
void     free_imatrix_1d(int*);
void     free_imatrix_2d(int**);
void     free_imatrix_3d(int***,int);
void     free_imatrix_4d(int****,int,int);

//>MatrixGestion
void  CopyMat(float**,float**,int,int);
void  CopyMat(int**,int**,int,int);
void  CopyMat(float**,int**,int,int);
void  CopyMat(int**,float**,int,int);
void  CopyMat(float***,float***,int,int);
void  CopyMat(int***,int***,int,int);
void  Recal(float**,int,int); 
void  Recal(int**,int,int);
void  Zeros(float**,int,int);
int   DiffMatNb(int**,int**,int,int);

//>Random
float randomize(void);

//>File
int  GetLengthWidth(char*,int*,int*);
void load_image_pgm(char*,int**,int,int);
void load_image_ppm(char*,int***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePgm(char*,char*,int**,int,int);
void SaveImagePpm(char*,char*,int***,int,int); 
void SaveImagePpm(char*,char*,float***,int,int); 

//>Kmean
int Identical(float*,float**,int,int);
void KmeanFast(float**,int,int,int,int*,int,int);

//>FusionRegions
void Paint(float**,int**,int,int,int,int,int);
void ConvertClassRegion(float**,int,int);
int  ComputeNumberRegions(float**,int,int);

//>Gestion
void Duplication(int**,int**,int,int,int);

//>Fusion Model
int   NumberRegionMax(int***,int,int,int);
void  ComputeMatProbVoI(int***,int**,int,int,int,int***,int);
void  ComputePropClustKprime(int***,int**,int,int,int,int);
void  ComputePropClustK(int*,int**,int,int,int);
float VariationInformation(int**,int**,int,int);
float MoyVariationInformation(int**,int***,int,int,int,int);
int   SelectSegMap(int***,int,int,int,float*);
void  Classify(int***,int,int,int,float*);
void  sort(float**,int,int,int);
void  swap(float*,float*); 
void  FillVectNeighb(int**,int,int,int*,int,int,int);
int   GiveRandomLab(int*,int);
float ComputeLocNrjVoI(int**,int*,int,int,int,int,int,int***,int,int***,int**,int);
void  ICM_VoILoc(int**,int**,int***,int,int,int,int);

//>Voibfm
void VoibfmM(int***,int,float**,int,int);
void VoibfmM2(int***,int,float**,int,int);
void Voibfm(int***,int,float**,int,int);
void Voibfm_(int***,int,float**,int,int);
void VoibfmI(int***,int,float**,int,int);

//------------------------------------------------
// FunctionSCVOIC2.cc
//------------------------------------------------

//>Gestion SCVOIC
void LoadTabSegAndImg(int****,int***,int,int,int,int);
void LoadTabSegSqAndImg(int****,int***,int,int,int,int);

void Normalize(int***,int,int,int);
void VisuMatrix(float**,int,int);

void VisuTabSegAll(int***,int,int,int,int*,int,int***,int,char*);
void VisuTabSegAll_Img(int****,int,int,int,int*,int,int***,int,char*);
void VisuTabSegAll_Seg(int****,int***,int,int,int,int*,int,int***,int,char*);
void Visu2DMapppingMDS_Img(int****,int,int,int,float**,int,float);
void Visu2DMapppingMDS_Seg(int****,int***,int,int,int,float**,int,float);
void Visu2DMapppingMDS_Img_E(int****,int,int,int,float**,int,float,float,float);
void Visu2DMapppingMDS_Seg_E(int****,int***,int,int,int,float**,int,float,float,float);
void Visu2D_Img(int****,int,int,int,char*);
void Visu2D_Img(int***,int,int,int,char*);
void VisuAgglomerations(int**,int****,int,int,int,int,char*);

float WithinInertieVOI(int***,int,int,int,int,int*,int***);
float BetweenInertieVOI(int,int,int,int***);
void  DownSamplingVctSeg(int***,int,int,int,int,int***);
void  UpSampling(int**,int**,int,int,int);
void  CompMatxDistVOI(int***,int,int,int,float**);
float ComputeDiversity(float**,int);
void  RangeAlwaysPositive(float**,int,int);
void  ComputeStat(float**,int,int,float**);
void  ComputeSqrtMatrix(float**,int,int);

//>K-Means SCVOIC
void KmeansVOI(int***,int,int,int,int,int*,int***,int);
void KmeansVOI_InitMatx(int***,int,int,int,int,int*,int***,int);
void ComputeCtr(int***,int,int,int,int,int*,int***,int);

//>HierarchicalClustering SCVOIC
void HierarCluster(int***,int,int,int,int***,int**,int,int);
void VisuHierCl(int****,int***,int,int,int,int***,int**,int);
void SeekNbClusters(int*,int,int,int**);
