//------------------------------------------------------
// module  : SCVOIC.cc
// author  : Ayman Khlif and Mignotte Max
// date    : 
// version : 1.0
// language: C++
// note    :
//------------------------------------------------------
//  

//------------------------------------------------
// INCLUDED FILES ---------------------------------
//------------------------------------------------
#include "SCVOIC.h"

//------------------------------------------------
// CONSTANT --------------------------------------
//------------------------------------------------
const int   METHOD=0;

//------------------------------------------------
// VARIABLES GLOBALES ----------------------------
//------------------------------------------------
char Extension[NCHAR];
char QueryDrawingFileName[NCHAR];

int   method;
int   nbclass;
int   dimmap;
int   init;

int   zoom;
int   flag_squa;
int   flag_save;
int   flag_quit;

//---------------------------------------------------------
// Enregistre les arguments de la ligne de commande      
//---------------------------------------------------------
void read_arguments(int argc,char** argv)
{
 int i;

   //Options
  if (argc<2) 
    { printf("\n Usage %s",argv[0]); 
      printf("\n Options : value by default indicated in ()");
      printf("\n            -----------------------------------------");
      printf("\n            -m Method  > [%d]",METHOD);
      printf("\n               (1:VoiDistMatx+MDS)");
      printf("\n               (2:VoiKmean)");  
      printf("\n               (3:HierarchicalClust)");   
      printf("\n               (4:FarestPointAndCenterInformation)");  
      printf("\n               (5:QueryByDrawing)");   
      printf("\n            -------------"); 
      printf("\n            -r NbClass  > [%d]",NBCLASS);
      printf("\n            -p DimMap   > [%d]",DIMMAPOUT);
      printf("\n            -t Init   > [%d]",INIT);
      printf("\n               (Init > =0:HorVert  =1:BestNSEGSL>H  =2:BestNSEGS)");
      printf("\n            -------------"); 
      printf("\n            -i [Img. in pgm format with size:321x321]");
      printf("\n            -------------");   
      printf("\n            -c Non-Squared Img  (%d)",SQUA);
      printf("\n            -------------");
      printf("\n");
      printf("\n  Example: %s -m 1 -r 8",argv[0]);
      printf("\n  Example: %s -m 2 -r 8",argv[0]);
      printf("\n  Example: %s -m 3",argv[0]);
      printf("\n  Example: %s -m 4",argv[0]);
      printf("\n  Example: %s -m 5 -i DrawingQuery001.pgm",argv[0]);
      printf("\n\n\n\n\n");
      exit(-1); }

    
   //Boucle 
   for(i=1;i<argc;i++)
     {   
          switch(argv[i][1])
          {    
           case 'm': method=atoi(argv[++i]);    break;
                  
           case 'r': nbclass=atoi(argv[++i]); break;  
           case 'p': dimmap=atoi(argv[++i]);  break;
           case 't': init=atoi(argv[++i]);    break;  

           case 'i': strcpy(QueryDrawingFileName,argv[++i]); break;              
          
           case 'z': zoom=atoi(argv[++i]);      break;
           case 'c': flag_squa=0;               break;  
	   case 'q': flag_quit=1;               break;
           case 's': flag_save=1;               break;                   
          }    
     } 
 }

//----------------------------------------------------------
//----------------------------------------------------------
// PROGRAMME PRINCIPAL -------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
int main(int argc,char** argv)
{
 int   flag;
 
 //Initialisation
 //--------------
 method=METHOD;
 nbclass=NBCLASS;
 dimmap=DIMMAPOUT;
 init=INIT;
 
 zoom=ZOOM;
 flag_squa=SQUA;
 flag_save=SAVE;
 flag_quit=QUIT;
 flag=0;

 //Read Arguments
 //--------------
 read_arguments(argc,argv);


 //Affiche options
 //---------------
 printf("\n\n\n");
 printf("\n\n Info: ");
 printf("\n -----");
 printf("\n Method [%d]",method);
 printf("\n -----");   
 printf("\n NbClass [%d]",nbclass);
 printf("\n DimMap  [%d]",dimmap);
 printf("\n Init  [%d]",init);
 printf("\n -----");
 if (method==5) printf("[QueryDrawing:%s]",QueryDrawingFileName);
 printf("\n -----");
 printf("\n Zoom: %d",zoom);
 if (flag_squa)   printf("\n -> Avec Img Carre");
 if (flag_save)   printf("\n -> Avec Sauvegarde");
 if (flag_quit)   printf("\n -> Avec Quit");
 printf("\n -----\n\n");


 //------------------------------------------
 //-------- Algorithme SCVOIC ----------------
 //------------------------------------------
 SCVOIC voic(nbclass);

  //Options 
  voic.DimMap=dimmap;
  voic.Init=init;
  voic.flag_squa=flag_squa;
  voic.flag_save=flag_save;
  strcpy(voic.QueryDrawingFileName,QueryDrawingFileName);
 
  //ClusterSeg
  if (method==1)  voic.VoiDistMatxForMDS();
  if (method==2)  voic.KmeanClusteringSeg();
  if (method==3)  voic.VoiHierarchicalClustering();
  if (method==4)  voic.FarestPointAndCenterInformation();
  if (method==5)  voic.QueryByDrawing();

  //>End
  printf("\n C'est fini... \n");
  return 0;
 }
 


